//+------------------------------------------------------------------+
//|                                                  LaguerreRSI.mq4 |
//|                                                       peregrinus |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "peregrinus"
#property link      ""

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 1
#property indicator_color1 DarkGray
//---- input parameters
extern double    g=0.6;
//---- buffers
double LRSI[];
double L0[];
double L1[];
double L2[];
double L3[];
//---- variables
double cu,cd;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicators
   IndicatorBuffers(5);
   SetLevelValue(0,25);
   SetLevelValue(1,75);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,LRSI);
   SetIndexBuffer(1,L0);
   SetIndexBuffer(2,L1);
   SetIndexBuffer(3,L2);
   SetIndexBuffer(4,L3);
//---- name for DataWindow and indicator subwindow label
   short_name="LRSI("+g+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
//   SetIndexDrawBegin(0,10);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| LaGuerre RSI                             |
//+------------------------------------------------------------------+
int start()
  {
   int    i,counted_bars=IndicatorCounted();
//---- 
   i=Bars-counted_bars-1;
   while(i>=0)
//      for(i=Bars-counted_bars-1;i>=0;i--)
     {
      L0[i]=(1-g)*Close[i] + g*L0[i+1];
      L1[i]=-g*L0[i] + L0[i+1] + g*L1[i+1];
      L2[i]=-g*L1[i] + L1[i+1] + g*L2[i+1];
      L3[i]=-g*L2[i] + L2[i+1] + g*L3[i+1];
      
      cd=0;
      cu=0;
      if (L0[i]>=L1[i]) cu=L0[i]-L1[i];
      else cd=L1[i]-L0[i];
      if (L1[i]>=L2[i]) cu+=L1[i]-L2[i];
      else cd+=L2[i]-L1[i];
      if (L2[i]>=L3[i]) cu+=L2[i]-L3[i];
      else cd+=L3[i]-L2[i];
      if (cu+cd!=0) LRSI[i]=100*cu/(cu+cd);    
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+